//
//  BTmsr.h
//  BTmsrSDK
//
//  V1.01
//  Modified by Xinhu Li on 12-9-13 IDTECH 
//

#import <Foundation/Foundation.h>
#import <ExternalAccessory/ExternalAccessory.h>


///////////////////////////////////////

typedef enum{
    EPT_NOKEY = 0x30,
    EPT_TDES,
    EPT_AES
}Encryption_Type;

typedef enum{
    PRE_AMBLE =0x02,
       POST_AMBLE
}PostPreamble;

typedef enum{
    BOTH_DIRECTION=0x31,
    HEAD_DIRECTION,
    HEAD_AGAINST,
    RAW_DATA
    
}DecodingMethod;

typedef enum{
    KEY_FIXED=0x30,
    KEY_DUKPT    
}KeyManagementType;

typedef enum{
    TRACK_1=0x31,
    TRACK_2,
    TRACK_1_and_2,
    TRACK_3,
    TRACK_1_and_3,
    TRACK_2_and_3,
    TRACK_ALL,
    TRACK_ANY1,
    TRACK_ANY2    
}MagneticTrack;

typedef enum{
    TRACK1_ID= 1,
    TRACK2_ID,
    TRACK3_ID
}TrackID;

/////----------------------------------

@protocol BTmsrDelegate;

@interface BTmsr : NSObject<EAAccessoryDelegate>{
  id<BTmsrDelegate> delegate;
}

@property(nonatomic, assign) id<BTmsrDelegate> delegate;

-(BOOL)open;
-(void)close;

-(char) GetSecurityLevel;
-(Byte)GetEncryptionType;

-(NSString*) GetFirmwareVersion;
-(NSString*) GetSerialNumber;
-(NSString*) GetEnzyModuleFWVersion;
-(NSString*) GetEnzyBDAddress;
-(NSData*) directIO:(NSData*)rawBytes;

-(NSData*) GetAllSettings;
-(BOOL)SetAllSettingDefault;

-(BOOL)SetMSREnable:(BOOL)Value;
-(BOOL)SetPostamble:(unsigned char)PostPreamble ;//03, and so on
-(BOOL)SetPreamble: (unsigned char)PostPreamble; //02, and so on
-(BOOL)SetDecodingMethod:(unsigned char)DecodingMethod; //31,32,33,34
-(BOOL)SetErrorIndication;
-(BOOL)SetEnhance;
-(Byte)GetDecodingMethod;
-(BOOL)SetEncryptionType: (unsigned char)Encryption_Type;  //31: TDES; 32: AES
-(BOOL)SetKeyManagementType:(unsigned char) KeyManagementType;//30: fixed; 31: DUKPT
-(Byte)GetKeyManagementType;
-(BOOL)SetTracksSelection:(unsigned char) TracksFlag;//30 ~ 39
-(Byte)GetTracksSelection;
-(BOOL)SetTrackSeparator:(unsigned char)TrackSeparator;
-(Byte)GetTrackSeparator;
-(BOOL)SetTerminator:(unsigned char)Terminator;
-(Byte)GetTerminator;
-(BOOL)SetTrackPrefix:(short)TrackID:(NSData*)Prefix;
-(NSString*)GetTrackPrefix:(short)TrackID;
-(BOOL)SetTrackSuffix:(short)TrackID:(NSData*) Suffix;
-(NSString*)GetTrackSuffix:(short)TrackID;


-(BOOL) ParseCardData;
-(BOOL) ParseCardData1;
-(BOOL) ParseCardData2;
-(NSString*) GetCardType;
-(NSString*) GetTrack1;
-(NSString*) GetTrack2;
-(NSString*) GetTrack3;
-(NSData*) GetTrack11;
-(NSData *) GetTrack12;
-(NSData*) GetTrack13;
-(NSData*) GetTrack1_EncryptedData;
-(NSData*) GetTrack2_EncryptedData;
-(NSData*) GetTrack3_EncryptedData;
-(NSData*) GetKSN;
-(NSData*) GetSessionID;

@end
